All the mail mirrored from lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality
@ 2024-04-30  3:31 Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 1/4] selftests: ifs: verify test interfaces are created by the driver Pengfei Xu
                   ` (5 more replies)
  0 siblings, 6 replies; 9+ messages in thread
From: Pengfei Xu @ 2024-04-30  3:31 UTC (permalink / raw
  To: Shuah Khan, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, Pengfei Xu, ashok.raj,
	sathyanarayanan.kuppuswamy

To verify IFS (In Field Scan [1]) driver functionality, add the following 6
test cases:
  1. Verify that IFS sysfs entries are created after loading the IFS module
  2. Check if loading an invalid IFS test image fails and loading a valid
     one succeeds
  3. Perform IFS scan test on each CPU using all the available image files
  4. Perform IFS scan with first test image file on a random CPU for 3
     rounds
  5. Perform IFS ARRAY BIST(Board Integrated System Test) test on each CPU
  6. Perform IFS ARRAY BIST test on a random CPU for 3 rounds

These are not exhaustive, but some minimal test runs to check various
parts of the driver. Some negative tests are also included.

[1] https://docs.kernel.org/arch/x86/ifs.html

Pengfei Xu (4):
  selftests: ifs: verify test interfaces are created by the driver
  selftests: ifs: verify test image loading functionality
  selftests: ifs: verify IFS scan test functionality
  selftests: ifs: verify IFS ARRAY BIST functionality

 MAINTAINERS                                   |   1 +
 tools/testing/selftests/Makefile              |   1 +
 .../drivers/platform/x86/intel/ifs/Makefile   |   6 +
 .../platform/x86/intel/ifs/test_ifs.sh        | 496 ++++++++++++++++++
 4 files changed, 504 insertions(+)
 create mode 100644 tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
 create mode 100755 tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh

-- 
2.43.0


^ permalink raw reply	[flat|nested] 9+ messages in thread

* [PATCH v1 1/4] selftests: ifs: verify test interfaces are created by the driver
  2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
@ 2024-04-30  3:31 ` Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 2/4] selftests: ifs: verify test image loading functionality Pengfei Xu
                   ` (4 subsequent siblings)
  5 siblings, 0 replies; 9+ messages in thread
From: Pengfei Xu @ 2024-04-30  3:31 UTC (permalink / raw
  To: Shuah Khan, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, Pengfei Xu, ashok.raj,
	sathyanarayanan.kuppuswamy

IFS (In Field Scan) driver exposes its functionality via sysfs interfaces.
Applications prepare and exercise the tests by interacting with the
aforementioned sysfs files.

Verify that the necessary sysfs entries are created after loading the IFS
driver.

Initialize test variables needed for building subsequent kself-test cases.

Reviewed-by: Jithu Joseph <jithu.joseph@intel.com>
Co-developed-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Pengfei Xu <pengfei.xu@intel.com>
---
 MAINTAINERS                                   |   1 +
 tools/testing/selftests/Makefile              |   1 +
 .../drivers/platform/x86/intel/ifs/Makefile   |   6 +
 .../platform/x86/intel/ifs/test_ifs.sh        | 181 ++++++++++++++++++
 4 files changed, 189 insertions(+)
 create mode 100644 tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
 create mode 100755 tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh

diff --git a/MAINTAINERS b/MAINTAINERS
index f6dc90559341..2eb18207dfac 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -10951,6 +10951,7 @@ R:	Tony Luck <tony.luck@intel.com>
 S:	Maintained
 F:	drivers/platform/x86/intel/ifs
 F:	include/trace/events/intel_ifs.h
+F:	tools/testing/selftests/drivers/platform/x86/intel/ifs/
 
 INTEL INTEGRATED SENSOR HUB DRIVER
 M:	Srinivas Pandruvada <srinivas.pandruvada@linux.intel.com>
diff --git a/tools/testing/selftests/Makefile b/tools/testing/selftests/Makefile
index e1504833654d..adc023641502 100644
--- a/tools/testing/selftests/Makefile
+++ b/tools/testing/selftests/Makefile
@@ -19,6 +19,7 @@ TARGETS += drivers/dma-buf
 TARGETS += drivers/s390x/uvdevice
 TARGETS += drivers/net/bonding
 TARGETS += drivers/net/team
+TARGETS += drivers/platform/x86/intel/ifs
 TARGETS += dt
 TARGETS += efivarfs
 TARGETS += exec
diff --git a/tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile b/tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
new file mode 100644
index 000000000000..03d0449d307c
--- /dev/null
+++ b/tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
@@ -0,0 +1,6 @@
+# SPDX-License-Identifier: GPL-2.0
+# Makefile for ifs(In Field Scan) selftests
+
+TEST_PROGS := test_ifs.sh
+
+include ../../../../../lib.mk
diff --git a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
new file mode 100755
index 000000000000..54466d452b2f
--- /dev/null
+++ b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
@@ -0,0 +1,181 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# Test the functionality of the Intel IFS(In Field Scan) driver.
+#
+
+# Matched with kselftest framework: tools/testing/selftests/kselftest.h
+readonly KSFT_PASS=0
+readonly KSFT_FAIL=1
+readonly KSFT_XFAIL=2
+readonly KSFT_SKIP=4
+
+readonly IFS_SCAN_MODE="0"
+readonly IFS_PATH="/sys/devices/virtual/misc/intel_ifs"
+readonly IFS_SCAN_SYSFS_PATH="${IFS_PATH}_${IFS_SCAN_MODE}"
+readonly PASS="PASS"
+readonly FAIL="FAIL"
+readonly INFO="INFO"
+readonly XFAIL="XFAIL"
+readonly SKIP="SKIP"
+readonly IFS_NAME="intel_ifs"
+
+# Matches arch/x86/include/asm/intel-family.h and
+# drivers/platform/x86/intel/ifs/core.c requirement as follows
+readonly SAPPHIRERAPIDS_X="8f"
+readonly EMERALDRAPIDS_X="cf"
+
+readonly INTEL_FAM6="06"
+
+FML=""
+MODEL=""
+
+TRUE="true"
+FALSE="false"
+RESULT=$KSFT_PASS
+export INTERVAL_TIME=1
+# For IFS cleanup tags
+ORIGIN_IFS_LOADED=""
+IFS_LOG="/tmp/ifs_logs.$$"
+
+append_log()
+{
+	echo -e "$1" | tee -a "$IFS_LOG"
+}
+
+ifs_scan_result_summary()
+{
+	local failed_info pass_num skip_num fail_num
+
+	if [[ -e "$IFS_LOG" ]]; then
+		failed_info=$(grep ^"\[${FAIL}\]" "$IFS_LOG")
+		fail_num=$(grep -c ^"\[${FAIL}\]" "$IFS_LOG")
+		skip_num=$(grep -c ^"\[${SKIP}\]" "$IFS_LOG")
+		pass_num=$(grep -c ^"\[${PASS}\]" "$IFS_LOG")
+
+		if [[ "$fail_num" -ne 0 ]]; then
+			RESULT=$KSFT_FAIL
+			echo "[$INFO] IFS test failure summary:"
+			echo "$failed_info"
+		elif [[ "$skip_num" -ne 0 ]]; then
+			RESULT=$KSFT_SKIP
+		fi
+			echo "[$INFO] IFS test pass:$pass_num, skip:$skip_num, fail:$fail_num"
+	else
+		echo "[$INFO] No file $IFS_LOG for IFS scan summary"
+	fi
+}
+
+ifs_cleanup()
+{
+	lsmod | grep -q "$IFS_NAME" && [[ "$ORIGIN_IFS_LOADED" == "$FALSE" ]] && {
+		echo "[$INFO] modprobe -r $IFS_NAME"
+		modprobe -r "$IFS_NAME"
+	}
+
+	ifs_scan_result_summary
+	[[ -e "$IFS_LOG" ]] && rm -rf "$IFS_LOG"
+
+	echo "[RESULT] IFS test exit with $RESULT"
+	exit "$RESULT"
+}
+
+test_exit()
+{
+	local info=$1
+	RESULT=$2
+
+	declare -A EXIT_MAP
+	EXIT_MAP[$KSFT_PASS]=$PASS
+	EXIT_MAP[$KSFT_FAIL]=$FAIL
+	EXIT_MAP[$KSFT_XFAIL]=$XFAIL
+	EXIT_MAP[$KSFT_SKIP]=$SKIP
+
+	append_log "[${EXIT_MAP[$RESULT]}] $info"
+	ifs_cleanup
+}
+
+get_cpu_fms()
+{
+	FML=$(grep -m 1 "family" /proc/cpuinfo | awk -F ":" '{printf "%02x",$2;}')
+	MODEL=$(grep -m 1 "model" /proc/cpuinfo | awk -F ":" '{printf "%02x",$2;}')
+}
+
+check_cpu_ifs_support_interval_time()
+{
+	get_cpu_fms
+
+	if [[ "$FML" != "$INTEL_FAM6" ]]; then
+		test_exit "CPU family:$FML does not support IFS" "$KSFT_SKIP"
+	fi
+
+	# Ucode has time interval requirement for IFS scan on same CPU as follows:
+	case $MODEL in
+		"$SAPPHIRERAPIDS_X")
+			INTERVAL_TIME=180;
+			;;
+		"$EMERALDRAPIDS_X")
+			INTERVAL_TIME=30;
+			;;
+		*)
+			# Set default interval time for other platforms
+			INTERVAL_TIME=1;
+			append_log "[$INFO] CPU FML:$FML model:0x$MODEL, default: 1s interval time"
+			;;
+	esac
+}
+
+check_ifs_loaded()
+{
+	local ifs_info=""
+
+	ifs_info=$(lsmod | grep "$IFS_NAME")
+	if [[ -z "$ifs_info" ]]; then
+		append_log "[$INFO] modprobe $IFS_NAME"
+		modprobe "$IFS_NAME" || {
+			test_exit "Check if CONFIG_INTEL_IFS is set to m or \
+platform doesn't support ifs" "$KSFT_SKIP"
+		}
+		ifs_info=$(lsmod | grep "$IFS_NAME")
+		[[ -n "$ifs_info" ]] || test_exit "No ifs module listed by lsmod" "$KSFT_FAIL"
+	fi
+}
+
+test_ifs_scan_entry()
+{
+	local ifs_info=""
+	local ifs_entry=""
+
+	ifs_info=$(lsmod | grep "$IFS_NAME")
+
+	if [[ -z "$ifs_info" ]]; then
+		ORIGIN_IFS_LOADED="$FALSE"
+		check_ifs_loaded
+	else
+		ORIGIN_IFS_LOADED="$TRUE"
+		append_log "[$INFO] Module $IFS_NAME is already loaded"
+	fi
+
+	ifs_entry=$(ls "$IFS_SCAN_SYSFS_PATH" 2>/dev/null)
+	if [[ -z "$ifs_entry" ]]; then
+		test_exit "No sysfs entry in $IFS_SCAN_SYSFS_PATH" "$KSFT_FAIL"
+	else
+		append_log "[$PASS] IFS sysfs $IFS_SCAN_SYSFS_PATH entry is created\n"
+	fi
+}
+
+prepare_ifs_test_env()
+{
+	check_cpu_ifs_support_interval_time
+}
+
+test_ifs()
+{
+	prepare_ifs_test_env
+
+	test_ifs_scan_entry
+}
+
+trap ifs_cleanup SIGTERM SIGINT
+test_ifs
+ifs_cleanup
-- 
2.43.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* [PATCH v1 2/4] selftests: ifs: verify test image loading functionality
  2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 1/4] selftests: ifs: verify test interfaces are created by the driver Pengfei Xu
@ 2024-04-30  3:31 ` Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 3/4] selftests: ifs: verify IFS scan test functionality Pengfei Xu
                   ` (3 subsequent siblings)
  5 siblings, 0 replies; 9+ messages in thread
From: Pengfei Xu @ 2024-04-30  3:31 UTC (permalink / raw
  To: Shuah Khan, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, Pengfei Xu, ashok.raj,
	sathyanarayanan.kuppuswamy

Scan test image files have to be loaded before starting IFS test.

Verify that In Field scan driver is able to load valid test image files.

Also check if loading an invalid test image file fails.

Reviewed-by: Jithu Joseph <jithu.joseph@intel.com>
Co-developed-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Pengfei Xu <pengfei.xu@intel.com>
---
 .../platform/x86/intel/ifs/test_ifs.sh        | 121 +++++++++++++++++-
 1 file changed, 120 insertions(+), 1 deletion(-)

diff --git a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
index 54466d452b2f..2a4df745bf6f 100755
--- a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
+++ b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
@@ -10,6 +10,7 @@ readonly KSFT_FAIL=1
 readonly KSFT_XFAIL=2
 readonly KSFT_SKIP=4
 
+readonly IMG_PATH="/lib/firmware/intel/ifs_0"
 readonly IFS_SCAN_MODE="0"
 readonly IFS_PATH="/sys/devices/virtual/misc/intel_ifs"
 readonly IFS_SCAN_SYSFS_PATH="${IFS_PATH}_${IFS_SCAN_MODE}"
@@ -29,14 +30,18 @@ readonly INTEL_FAM6="06"
 
 FML=""
 MODEL=""
-
+STEPPING=""
+CPU_FMS=""
 TRUE="true"
 FALSE="false"
 RESULT=$KSFT_PASS
+IMAGE_NAME=""
 export INTERVAL_TIME=1
 # For IFS cleanup tags
 ORIGIN_IFS_LOADED=""
+IFS_IMAGE_NEED_RESTORE=$FALSE
 IFS_LOG="/tmp/ifs_logs.$$"
+DEFAULT_IMG_ID=""
 
 append_log()
 {
@@ -68,6 +73,13 @@ ifs_scan_result_summary()
 
 ifs_cleanup()
 {
+	echo "[$INFO] Restore environment after IFS test"
+
+	# Restore ifs origin image if origin image backup step is needed
+	[[ "$IFS_IMAGE_NEED_RESTORE" == "$TRUE" ]] && {
+		mv -f "$IMG_PATH"/"$IMAGE_NAME"_origin "$IMG_PATH"/"$IMAGE_NAME"
+	}
+
 	lsmod | grep -q "$IFS_NAME" && [[ "$ORIGIN_IFS_LOADED" == "$FALSE" ]] && {
 		echo "[$INFO] modprobe -r $IFS_NAME"
 		modprobe -r "$IFS_NAME"
@@ -80,6 +92,21 @@ ifs_cleanup()
 	exit "$RESULT"
 }
 
+do_cmd()
+{
+	local cmd=$*
+	local ret=""
+
+	append_log "[$INFO] $cmd"
+	eval "$cmd"
+	ret=$?
+	if [[ $ret -ne 0 ]]; then
+		append_log "[$FAIL] $cmd failed. Return code is $ret"
+		RESULT=$KSFT_XFAIL
+		ifs_cleanup
+	fi
+}
+
 test_exit()
 {
 	local info=$1
@@ -99,6 +126,8 @@ get_cpu_fms()
 {
 	FML=$(grep -m 1 "family" /proc/cpuinfo | awk -F ":" '{printf "%02x",$2;}')
 	MODEL=$(grep -m 1 "model" /proc/cpuinfo | awk -F ":" '{printf "%02x",$2;}')
+	STEPPING=$(grep -m 1 "stepping" /proc/cpuinfo | awk -F ":" '{printf "%02x",$2;}')
+	CPU_FMS="${FML}-${MODEL}-${STEPPING}"
 }
 
 check_cpu_ifs_support_interval_time()
@@ -164,9 +193,93 @@ test_ifs_scan_entry()
 	fi
 }
 
+load_image()
+{
+	local image_id=$1
+	local image_info=""
+	local ret=""
+
+	check_ifs_loaded
+	if [[ -e "${IMG_PATH}/${IMAGE_NAME}" ]]; then
+		append_log "[$INFO] echo 0x$image_id > ${IFS_SCAN_SYSFS_PATH}/current_batch"
+		echo "0x$image_id" > "$IFS_SCAN_SYSFS_PATH"/current_batch 2>/dev/null
+		ret=$?
+		[[ "$ret" -eq 0 ]] || {
+			append_log "[$FAIL] Load ifs image $image_id failed with ret:$ret\n"
+			return "$ret"
+		}
+		image_info=$(cat ${IFS_SCAN_SYSFS_PATH}/current_batch)
+		if [[ "$image_info" == 0x"$image_id" ]]; then
+			append_log "[$PASS] load IFS current_batch:$image_info"
+		else
+			append_log "[$FAIL] current_batch:$image_info is not expected:$image_id"
+			return "$KSFT_FAIL"
+		fi
+	else
+		append_log "[$FAIL] No IFS image file ${IMG_PATH}/${IMAGE_NAME}"\
+		return "$KSFT_FAIL"
+	fi
+	return 0
+}
+
+test_load_origin_ifs_image()
+{
+	local image_id=$1
+
+	IMAGE_NAME="${CPU_FMS}-${image_id}.scan"
+
+	load_image "$image_id" || return $?
+	return 0
+}
+
+test_load_bad_ifs_image()
+{
+	local image_id=$1
+
+	IMAGE_NAME="${CPU_FMS}-${image_id}.scan"
+
+	do_cmd "mv -f ${IMG_PATH}/${IMAGE_NAME} ${IMG_PATH}/${IMAGE_NAME}_origin"
+
+	# Set IFS_IMAGE_NEED_RESTORE to true before corrupt the origin ifs image file
+	IFS_IMAGE_NEED_RESTORE=$TRUE
+	do_cmd "dd if=/dev/urandom of=${IMG_PATH}/${IMAGE_NAME} bs=1K count=6 2>/dev/null"
+
+	# Use the specified judgment for negative testing
+	append_log "[$INFO] echo 0x$image_id > ${IFS_SCAN_SYSFS_PATH}/current_batch"
+	echo "0x$image_id" > "$IFS_SCAN_SYSFS_PATH"/current_batch 2>/dev/null
+	ret=$?
+	if [[ "$ret" -ne 0 ]]; then
+		append_log "[$PASS] Load invalid ifs image failed with ret:$ret not 0 as expected"
+	else
+		append_log "[$FAIL] Load invalid ifs image ret:$ret unexpectedly"
+	fi
+
+	do_cmd "mv -f ${IMG_PATH}/${IMAGE_NAME}_origin ${IMG_PATH}/${IMAGE_NAME}"
+	IFS_IMAGE_NEED_RESTORE=$FALSE
+}
+
+test_bad_and_origin_ifs_image()
+{
+	local image_id=$1
+
+	append_log "[$INFO] Test loading bad and then loading original IFS image:"
+	test_load_origin_ifs_image "$image_id" || return $?
+	test_load_bad_ifs_image "$image_id"
+	# Load origin image again and make sure it's worked
+	test_load_origin_ifs_image "$image_id" || return $?
+	append_log "[$INFO] Loading invalid IFS image and then loading initial image passed.\n"
+}
+
 prepare_ifs_test_env()
 {
 	check_cpu_ifs_support_interval_time
+
+	DEFAULT_IMG_ID=$(find $IMG_PATH -maxdepth 1 -name "${CPU_FMS}-[0-9a-fA-F][0-9a-fA-F].scan" \
+			 2>/dev/null \
+			 | sort \
+			 | head -n 1 \
+			 | awk -F "-" '{print $NF}' \
+			 | cut -d "." -f 1)
 }
 
 test_ifs()
@@ -174,6 +287,12 @@ test_ifs()
 	prepare_ifs_test_env
 
 	test_ifs_scan_entry
+
+	if [[ -z "$DEFAULT_IMG_ID" ]]; then
+		append_log "[$SKIP] No proper ${IMG_PATH}/${CPU_FMS}-*.scan, skip ifs_0 scan"
+	else
+		test_bad_and_origin_ifs_image "$DEFAULT_IMG_ID"
+	fi
 }
 
 trap ifs_cleanup SIGTERM SIGINT
-- 
2.43.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* [PATCH v1 3/4] selftests: ifs: verify IFS scan test functionality
  2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 1/4] selftests: ifs: verify test interfaces are created by the driver Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 2/4] selftests: ifs: verify test image loading functionality Pengfei Xu
@ 2024-04-30  3:31 ` Pengfei Xu
  2024-04-30  3:31 ` [PATCH v1 4/4] selftests: ifs: verify IFS ARRAY BIST functionality Pengfei Xu
                   ` (2 subsequent siblings)
  5 siblings, 0 replies; 9+ messages in thread
From: Pengfei Xu @ 2024-04-30  3:31 UTC (permalink / raw
  To: Shuah Khan, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, Pengfei Xu, ashok.raj,
	sathyanarayanan.kuppuswamy

Two selftests are added to verify IFS scan test feature:

1. Perform IFS scan test once on each CPU using all the available image
   files.
2. Perform IFS scan test with the default image on a random cpu for 3
   rounds.

Reviewed-by: Jithu Joseph <jithu.joseph@intel.com>
Co-developed-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Pengfei Xu <pengfei.xu@intel.com>
---
 .../platform/x86/intel/ifs/test_ifs.sh        | 190 +++++++++++++++++-
 1 file changed, 189 insertions(+), 1 deletion(-)

diff --git a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
index 2a4df745bf6f..63d13400af4f 100755
--- a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
+++ b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
@@ -10,16 +10,25 @@ readonly KSFT_FAIL=1
 readonly KSFT_XFAIL=2
 readonly KSFT_SKIP=4
 
+readonly CPU_SYSFS="/sys/devices/system/cpu"
+readonly CPU_OFFLINE_SYSFS="${CPU_SYSFS}/offline"
 readonly IMG_PATH="/lib/firmware/intel/ifs_0"
 readonly IFS_SCAN_MODE="0"
+readonly IFS_ARRAY_BIST_SCAN_MODE="1"
 readonly IFS_PATH="/sys/devices/virtual/misc/intel_ifs"
 readonly IFS_SCAN_SYSFS_PATH="${IFS_PATH}_${IFS_SCAN_MODE}"
+readonly RUN_TEST="run_test"
+readonly STATUS="status"
+readonly DETAILS="details"
+readonly STATUS_PASS="pass"
 readonly PASS="PASS"
 readonly FAIL="FAIL"
 readonly INFO="INFO"
 readonly XFAIL="XFAIL"
 readonly SKIP="SKIP"
 readonly IFS_NAME="intel_ifs"
+readonly ALL="all"
+readonly SIBLINGS="siblings"
 
 # Matches arch/x86/include/asm/intel-family.h and
 # drivers/platform/x86/intel/ifs/core.c requirement as follows
@@ -28,6 +37,7 @@ readonly EMERALDRAPIDS_X="cf"
 
 readonly INTEL_FAM6="06"
 
+LOOP_TIMES=3
 FML=""
 MODEL=""
 STEPPING=""
@@ -36,11 +46,13 @@ TRUE="true"
 FALSE="false"
 RESULT=$KSFT_PASS
 IMAGE_NAME=""
-export INTERVAL_TIME=1
+INTERVAL_TIME=1
+OFFLINE_CPUS=""
 # For IFS cleanup tags
 ORIGIN_IFS_LOADED=""
 IFS_IMAGE_NEED_RESTORE=$FALSE
 IFS_LOG="/tmp/ifs_logs.$$"
+RANDOM_CPU=""
 DEFAULT_IMG_ID=""
 
 append_log()
@@ -48,6 +60,35 @@ append_log()
 	echo -e "$1" | tee -a "$IFS_LOG"
 }
 
+online_offline_cpu_list()
+{
+	local on_off=$1
+	local target_cpus=$2
+	local cpu=""
+	local cpu_start=""
+	local cpu_end=""
+	local i=""
+
+	if [[ -n "$target_cpus" ]]; then
+		for cpu in $(echo "$target_cpus" | tr ',' ' '); do
+			if [[ "$cpu" == *"-"* ]]; then
+				cpu_start=""
+				cpu_end=""
+				i=""
+				cpu_start=$(echo "$cpu" | cut -d "-" -f 1)
+				cpu_end=$(echo "$cpu" | cut -d "-" -f 2)
+				for((i=cpu_start;i<=cpu_end;i++)); do
+					append_log "[$INFO] echo $on_off > \
+${CPU_SYSFS}/cpu${i}/online"
+					echo "$on_off" > "$CPU_SYSFS"/cpu"$i"/online
+				done
+			else
+				set_target_cpu "$on_off" "$cpu"
+			fi
+		done
+	fi
+}
+
 ifs_scan_result_summary()
 {
 	local failed_info pass_num skip_num fail_num
@@ -80,6 +121,9 @@ ifs_cleanup()
 		mv -f "$IMG_PATH"/"$IMAGE_NAME"_origin "$IMG_PATH"/"$IMAGE_NAME"
 	}
 
+	# Restore the CPUs to the state before testing
+	[[ -z "$OFFLINE_CPUS" ]] || online_offline_cpu_list "0" "$OFFLINE_CPUS"
+
 	lsmod | grep -q "$IFS_NAME" && [[ "$ORIGIN_IFS_LOADED" == "$FALSE" ]] && {
 		echo "[$INFO] modprobe -r $IFS_NAME"
 		modprobe -r "$IFS_NAME"
@@ -122,6 +166,23 @@ test_exit()
 	ifs_cleanup
 }
 
+online_all_cpus()
+{
+	local off_cpus=""
+
+	OFFLINE_CPUS=$(cat "$CPU_OFFLINE_SYSFS")
+	online_offline_cpu_list "1" "$OFFLINE_CPUS"
+
+	off_cpus=$(cat "$CPU_OFFLINE_SYSFS")
+	if [[ -z "$off_cpus" ]]; then
+		append_log "[$INFO] All CPUs are online."
+	else
+		append_log "[$XFAIL] There is offline cpu:$off_cpus after online all cpu!"
+		RESULT=$KSFT_XFAIL
+		ifs_cleanup
+	fi
+}
+
 get_cpu_fms()
 {
 	FML=$(grep -m 1 "family" /proc/cpuinfo | awk -F ":" '{printf "%02x",$2;}')
@@ -270,10 +331,135 @@ test_bad_and_origin_ifs_image()
 	append_log "[$INFO] Loading invalid IFS image and then loading initial image passed.\n"
 }
 
+ifs_test_cpu()
+{
+	local ifs_mode=$1
+	local cpu_num=$2
+	local image_id status details ret result result_info
+
+	echo "$cpu_num" > "$IFS_PATH"_"$ifs_mode"/"$RUN_TEST"
+	ret=$?
+
+	status=$(cat "${IFS_PATH}_${ifs_mode}/${STATUS}")
+	details=$(cat "${IFS_PATH}_${ifs_mode}/${DETAILS}")
+
+	if [[ "$ret" -eq 0 && "$status" == "$STATUS_PASS" ]]; then
+		result="$PASS"
+	else
+		result="$FAIL"
+	fi
+
+	cpu_num=$(cat "${CPU_SYSFS}/cpu${cpu_num}/topology/thread_siblings_list")
+
+	# There is no image file for IFS ARRAY BIST scan
+	if [[ -e "${IFS_PATH}_${ifs_mode}/current_batch" ]]; then
+		image_id=$(cat "${IFS_PATH}_${ifs_mode}/current_batch")
+		result_info=$(printf "[%s] ifs_%1d cpu(s):%s, current_batch:0x%02x, \
+ret:%2d, status:%s, details:0x%016x" \
+			     "$result" "$ifs_mode" "$cpu_num" "$image_id" "$ret" \
+			     "$status" "$details")
+	else
+		result_info=$(printf "[%s] ifs_%1d cpu(s):%s, ret:%2d, status:%s, details:0x%016x" \
+			     "$result" "$ifs_mode" "$cpu_num" "$ret" "$status" "$details")
+	fi
+
+	append_log "$result_info"
+}
+
+ifs_test_cpus()
+{
+	local cpus_type=$1
+	local ifs_mode=$2
+	local image_id=$3
+	local cpu_max_num=""
+	local cpu_num=""
+
+	case "$cpus_type" in
+		"$ALL")
+			cpu_max_num=$(($(nproc) - 1))
+			cpus=$(seq 0 $cpu_max_num)
+			;;
+		"$SIBLINGS")
+			cpus=$(cat ${CPU_SYSFS}/cpu*/topology/thread_siblings_list \
+				| sed -e 's/,.*//' \
+				| sed -e 's/-.*//' \
+				| sort -n \
+				| uniq)
+			;;
+		*)
+			test_exit "Invalid cpus_type:$cpus_type" "$KSFT_XFAIL"
+			;;
+	esac
+
+	for cpu_num in $cpus; do
+		ifs_test_cpu "$ifs_mode" "$cpu_num"
+	done
+
+	if [[ -z "$image_id" ]]; then
+		append_log "[$INFO] ifs_$ifs_mode test $cpus_type cpus completed\n"
+	else
+		append_log "[$INFO] ifs_$ifs_mode $cpus_type cpus with $CPU_FMS-$image_id.scan \
+completed\n"
+	fi
+}
+
+test_ifs_same_cpu_loop()
+{
+	local ifs_mode=$1
+	local cpu_num=$2
+	local loop_times=$3
+
+	append_log "[$INFO] Test ifs mode $ifs_mode on CPU:$cpu_num for $loop_times rounds:"
+	[[ "$ifs_mode" == "$IFS_SCAN_MODE" ]] && {
+		load_image "$DEFAULT_IMG_ID" ||	return $?
+	}
+	for (( i=1; i<=loop_times; i++ )); do
+		append_log "[$INFO] Loop iteration: $i in total of $loop_times"
+		# Only IFS scan needs the interval time
+		if [[ "$ifs_mode" == "$IFS_SCAN_MODE" ]]; then
+			do_cmd "sleep $INTERVAL_TIME"
+		elif [[ "$ifs_mode" == "$IFS_ARRAY_BIST_SCAN_MODE" ]]; then
+			true
+		else
+			test_exit "Invalid ifs_mode:$ifs_mode" "$KSFT_XFAIL"
+		fi
+
+		ifs_test_cpu "$ifs_mode" "$cpu_num"
+	done
+	append_log "[$INFO] $loop_times rounds of ifs_$ifs_mode test on CPU:$cpu_num completed.\n"
+}
+
+test_ifs_scan_available_imgs()
+{
+	local image_ids=""
+	local image_id=""
+
+	append_log "[$INFO] Test ifs scan with available images:"
+	image_ids=$(find "$IMG_PATH" -maxdepth 1 -name "${CPU_FMS}-[0-9a-fA-F][0-9a-fA-F].scan" \
+		    2>/dev/null \
+		    | sort \
+		    | awk -F "-" '{print $NF}' \
+		    | cut -d "." -f 1)
+
+	for image_id in $image_ids; do
+		load_image "$image_id" || return $?
+
+		ifs_test_cpus "$SIBLINGS" "$IFS_SCAN_MODE" "$image_id"
+		# IFS scan requires time interval for the scan on the same CPU
+		do_cmd "sleep $INTERVAL_TIME"
+	done
+}
+
 prepare_ifs_test_env()
 {
+	local max_cpu=""
+
 	check_cpu_ifs_support_interval_time
 
+	online_all_cpus
+	max_cpu=$(($(nproc) - 1))
+	RANDOM_CPU=$(shuf -i 0-$max_cpu -n 1)
+
 	DEFAULT_IMG_ID=$(find $IMG_PATH -maxdepth 1 -name "${CPU_FMS}-[0-9a-fA-F][0-9a-fA-F].scan" \
 			 2>/dev/null \
 			 | sort \
@@ -292,6 +478,8 @@ test_ifs()
 		append_log "[$SKIP] No proper ${IMG_PATH}/${CPU_FMS}-*.scan, skip ifs_0 scan"
 	else
 		test_bad_and_origin_ifs_image "$DEFAULT_IMG_ID"
+		test_ifs_scan_available_imgs
+		test_ifs_same_cpu_loop "$IFS_SCAN_MODE" "$RANDOM_CPU" "$LOOP_TIMES"
 	fi
 }
 
-- 
2.43.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* [PATCH v1 4/4] selftests: ifs: verify IFS ARRAY BIST functionality
  2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
                   ` (2 preceding siblings ...)
  2024-04-30  3:31 ` [PATCH v1 3/4] selftests: ifs: verify IFS scan test functionality Pengfei Xu
@ 2024-04-30  3:31 ` Pengfei Xu
  2024-05-14 16:45 ` [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Shuah Khan
  2024-05-15  3:55 ` Kuppuswamy, Sathyanarayanan
  5 siblings, 0 replies; 9+ messages in thread
From: Pengfei Xu @ 2024-04-30  3:31 UTC (permalink / raw
  To: Shuah Khan, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, Pengfei Xu, ashok.raj,
	sathyanarayanan.kuppuswamy

There are two selftest scenarios for ARRAY BIST(Board Integrated System
Test) tests:

1. Perform IFS ARRAY BIST tests once on each CPU.
2. Perform IFS ARRAY BIST tests on a random CPU with 3 rounds.

These are not meant to be exhaustive, but are some minimal tests for
for checking IFS ARRAY BIST.

Reviewed-by: Jithu Joseph <jithu.joseph@intel.com>
Co-developed-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Ashok Raj <ashok.raj@intel.com>
Signed-off-by: Pengfei Xu <pengfei.xu@intel.com>
---
 .../selftests/drivers/platform/x86/intel/ifs/test_ifs.sh  | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
index 63d13400af4f..2ab310c4aaff 100755
--- a/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
+++ b/tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
@@ -481,6 +481,14 @@ test_ifs()
 		test_ifs_scan_available_imgs
 		test_ifs_same_cpu_loop "$IFS_SCAN_MODE" "$RANDOM_CPU" "$LOOP_TIMES"
 	fi
+
+	# SAPPHIRERAPID CPU could not support IFS ARRAY BIST scan
+	if [[ "$MODEL" == "$SAPPHIRERAPIDS_X" ]]; then
+		append_log "[$SKIP] SAPPHIRERAPID CPU, skip IFS ARRAY BIST scan"
+	else
+		ifs_test_cpus "$SIBLINGS" "$IFS_ARRAY_BIST_SCAN_MODE"
+		test_ifs_same_cpu_loop "$IFS_ARRAY_BIST_SCAN_MODE" "$RANDOM_CPU" "$LOOP_TIMES"
+	fi
 }
 
 trap ifs_cleanup SIGTERM SIGINT
-- 
2.43.0


^ permalink raw reply related	[flat|nested] 9+ messages in thread

* Re: [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality
  2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
                   ` (3 preceding siblings ...)
  2024-04-30  3:31 ` [PATCH v1 4/4] selftests: ifs: verify IFS ARRAY BIST functionality Pengfei Xu
@ 2024-05-14 16:45 ` Shuah Khan
  2024-05-14 17:39   ` Joseph, Jithu
  2024-05-15  3:55 ` Kuppuswamy, Sathyanarayanan
  5 siblings, 1 reply; 9+ messages in thread
From: Shuah Khan @ 2024-05-14 16:45 UTC (permalink / raw
  To: Pengfei Xu, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, ashok.raj, sathyanarayanan.kuppuswamy,
	Shuah Khan

On 4/29/24 21:31, Pengfei Xu wrote:
> To verify IFS (In Field Scan [1]) driver functionality, add the following 6
> test cases:
>    1. Verify that IFS sysfs entries are created after loading the IFS module
>    2. Check if loading an invalid IFS test image fails and loading a valid
>       one succeeds
>    3. Perform IFS scan test on each CPU using all the available image files
>    4. Perform IFS scan with first test image file on a random CPU for 3
>       rounds
>    5. Perform IFS ARRAY BIST(Board Integrated System Test) test on each CPU
>    6. Perform IFS ARRAY BIST test on a random CPU for 3 rounds
> 
> These are not exhaustive, but some minimal test runs to check various
> parts of the driver. Some negative tests are also included.
> 
> [1] https://docs.kernel.org/arch/x86/ifs.html
> 
> Pengfei Xu (4):
>    selftests: ifs: verify test interfaces are created by the driver
>    selftests: ifs: verify test image loading functionality
>    selftests: ifs: verify IFS scan test functionality
>    selftests: ifs: verify IFS ARRAY BIST functionality
> 
>   MAINTAINERS                                   |   1 +
>   tools/testing/selftests/Makefile              |   1 +
>   .../drivers/platform/x86/intel/ifs/Makefile   |   6 +
>   .../platform/x86/intel/ifs/test_ifs.sh        | 496 ++++++++++++++++++
>   4 files changed, 504 insertions(+)
>   create mode 100644 tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
>   create mode 100755 tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
> 

I am fine with adding a test. I would need ifs ack or reviewed-by.
I don't see ifs maintainer on on this thread.

thanks,
-- Shuah

^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality
  2024-05-14 16:45 ` [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Shuah Khan
@ 2024-05-14 17:39   ` Joseph, Jithu
  0 siblings, 0 replies; 9+ messages in thread
From: Joseph, Jithu @ 2024-05-14 17:39 UTC (permalink / raw
  To: Shuah Khan, Pengfei Xu, shuah, linux-kselftest
  Cc: linux-kernel, ashok.raj, sathyanarayanan.kuppuswamy

Hi Shuah,

On 5/14/2024 9:45 AM, Shuah Khan wrote:
> On 4/29/24 21:31, Pengfei Xu wrote:
>> To verify IFS (In Field Scan [1]) driver functionality, add the following 6
>> test cases:

...
>>
> 
> I am fine with adding a test. I would need ifs ack or reviewed-by.
> I don't see ifs maintainer on on this thread.

I am the IFS driver maintainer,  and I have reviewed the series and Pengfei has
my reviewed-by tags added in all the 4 patches.

Thanks
Jithu

^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality
  2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
                   ` (4 preceding siblings ...)
  2024-05-14 16:45 ` [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Shuah Khan
@ 2024-05-15  3:55 ` Kuppuswamy, Sathyanarayanan
  2024-05-15  5:15   ` Pengfei Xu
  5 siblings, 1 reply; 9+ messages in thread
From: Kuppuswamy, Sathyanarayanan @ 2024-05-15  3:55 UTC (permalink / raw
  To: Pengfei Xu, Shuah Khan, shuah, linux-kselftest
  Cc: linux-kernel, jithu.joseph, ashok.raj


On 4/29/24 8:31 PM, Pengfei Xu wrote:
> To verify IFS (In Field Scan [1]) driver functionality, add the following 6
> test cases:
>   1. Verify that IFS sysfs entries are created after loading the IFS module
>   2. Check if loading an invalid IFS test image fails and loading a valid
>      one succeeds
>   3. Perform IFS scan test on each CPU using all the available image files
>   4. Perform IFS scan with first test image file on a random CPU for 3
>      rounds
>   5. Perform IFS ARRAY BIST(Board Integrated System Test) test on each CPU
>   6. Perform IFS ARRAY BIST test on a random CPU for 3 rounds
>
> These are not exhaustive, but some minimal test runs to check various
> parts of the driver. Some negative tests are also included.
>
> [1] https://docs.kernel.org/arch/x86/ifs.html

Looks good to me.

Reviewed-by: Kuppuswamy Sathyanarayanan <sathyanarayanan.kuppuswamy@linux.intel.com>

> Pengfei Xu (4):
>   selftests: ifs: verify test interfaces are created by the driver
>   selftests: ifs: verify test image loading functionality
>   selftests: ifs: verify IFS scan test functionality
>   selftests: ifs: verify IFS ARRAY BIST functionality
>
>  MAINTAINERS                                   |   1 +
>  tools/testing/selftests/Makefile              |   1 +
>  .../drivers/platform/x86/intel/ifs/Makefile   |   6 +
>  .../platform/x86/intel/ifs/test_ifs.sh        | 496 ++++++++++++++++++
>  4 files changed, 504 insertions(+)
>  create mode 100644 tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
>  create mode 100755 tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
>
-- 
Sathyanarayanan Kuppuswamy
Linux Kernel Developer


^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality
  2024-05-15  3:55 ` Kuppuswamy, Sathyanarayanan
@ 2024-05-15  5:15   ` Pengfei Xu
  0 siblings, 0 replies; 9+ messages in thread
From: Pengfei Xu @ 2024-05-15  5:15 UTC (permalink / raw
  To: Kuppuswamy, Sathyanarayanan
  Cc: Shuah Khan, shuah, linux-kselftest, linux-kernel, jithu.joseph,
	ashok.raj

On 2024-05-14 at 20:55:11 -0700, Kuppuswamy, Sathyanarayanan wrote:
> 
> On 4/29/24 8:31 PM, Pengfei Xu wrote:
> > To verify IFS (In Field Scan [1]) driver functionality, add the following 6
> > test cases:
> >   1. Verify that IFS sysfs entries are created after loading the IFS module
> >   2. Check if loading an invalid IFS test image fails and loading a valid
> >      one succeeds
> >   3. Perform IFS scan test on each CPU using all the available image files
> >   4. Perform IFS scan with first test image file on a random CPU for 3
> >      rounds
> >   5. Perform IFS ARRAY BIST(Board Integrated System Test) test on each CPU
> >   6. Perform IFS ARRAY BIST test on a random CPU for 3 rounds
> >
> > These are not exhaustive, but some minimal test runs to check various
> > parts of the driver. Some negative tests are also included.
> >
> > [1] https://docs.kernel.org/arch/x86/ifs.html
> 
> Looks good to me.
> 
> Reviewed-by: Kuppuswamy Sathyanarayanan <sathyanarayanan.kuppuswamy@linux.intel.com>

Thanks for Sathya's tag, and thanks Shuah and Jithu also.

Best Regards,
Thanks!

> 
> > Pengfei Xu (4):
> >   selftests: ifs: verify test interfaces are created by the driver
> >   selftests: ifs: verify test image loading functionality
> >   selftests: ifs: verify IFS scan test functionality
> >   selftests: ifs: verify IFS ARRAY BIST functionality
> >
> >  MAINTAINERS                                   |   1 +
> >  tools/testing/selftests/Makefile              |   1 +
> >  .../drivers/platform/x86/intel/ifs/Makefile   |   6 +
> >  .../platform/x86/intel/ifs/test_ifs.sh        | 496 ++++++++++++++++++
> >  4 files changed, 504 insertions(+)
> >  create mode 100644 tools/testing/selftests/drivers/platform/x86/intel/ifs/Makefile
> >  create mode 100755 tools/testing/selftests/drivers/platform/x86/intel/ifs/test_ifs.sh
> >
> -- 
> Sathyanarayanan Kuppuswamy
> Linux Kernel Developer
> 

^ permalink raw reply	[flat|nested] 9+ messages in thread

end of thread, other threads:[~2024-05-15  5:15 UTC | newest]

Thread overview: 9+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2024-04-30  3:31 [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Pengfei Xu
2024-04-30  3:31 ` [PATCH v1 1/4] selftests: ifs: verify test interfaces are created by the driver Pengfei Xu
2024-04-30  3:31 ` [PATCH v1 2/4] selftests: ifs: verify test image loading functionality Pengfei Xu
2024-04-30  3:31 ` [PATCH v1 3/4] selftests: ifs: verify IFS scan test functionality Pengfei Xu
2024-04-30  3:31 ` [PATCH v1 4/4] selftests: ifs: verify IFS ARRAY BIST functionality Pengfei Xu
2024-05-14 16:45 ` [PATCH v1 0/4] add tests to verify IFS (In Field Scan) driver functionality Shuah Khan
2024-05-14 17:39   ` Joseph, Jithu
2024-05-15  3:55 ` Kuppuswamy, Sathyanarayanan
2024-05-15  5:15   ` Pengfei Xu

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.